"""autogenerated by genmsg_py from InterestPointRos.msg. Do not edit."""
import roslib.message
import struct

import flirtlib_ros.msg
import geometry_msgs.msg

class InterestPointRos(roslib.message.Message):
  _md5sum = "1246631fd365f90bb16bd48937597987"
  _type = "flirtlib_ros/InterestPointRos"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# Corresponds to the InterestPoint type in flirtlib
# Includes both the point location and optionally a descriptor

geometry_msgs/Pose2D pose

geometry_msgs/Point[] support_points

float32 scale

uint32 scale_level

DescriptorRos descriptor


================================================================================
MSG: geometry_msgs/Pose2D
# This expresses a position and orientation on a 2D manifold.

float64 x
float64 y
float64 theta
================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: flirtlib_ros/DescriptorRos
# Confirms to the Descriptor type in flirtlib
# For now, we only allow the beta grid descriptor

Vector[] hist
Vector[] variance
Vector[] hit
Vector[] miss

================================================================================
MSG: flirtlib_ros/Vector
# Vector message type used by a bunch of the flirtlib messages

float64[] vec
"""
  __slots__ = ['pose','support_points','scale','scale_level','descriptor']
  _slot_types = ['geometry_msgs/Pose2D','geometry_msgs/Point[]','float32','uint32','flirtlib_ros/DescriptorRos']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.
    
    The available fields are:
       pose,support_points,scale,scale_level,descriptor
    
    @param args: complete set of field values, in .msg order
    @param kwds: use keyword arguments corresponding to message field names
    to set specific fields. 
    """
    if args or kwds:
      super(InterestPointRos, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.pose is None:
        self.pose = geometry_msgs.msg.Pose2D()
      if self.support_points is None:
        self.support_points = []
      if self.scale is None:
        self.scale = 0.
      if self.scale_level is None:
        self.scale_level = 0
      if self.descriptor is None:
        self.descriptor = flirtlib_ros.msg.DescriptorRos()
    else:
      self.pose = geometry_msgs.msg.Pose2D()
      self.support_points = []
      self.scale = 0.
      self.scale_level = 0
      self.descriptor = flirtlib_ros.msg.DescriptorRos()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    @param buff: buffer
    @type  buff: StringIO
    """
    try:
      _x = self
      buff.write(_struct_3d.pack(_x.pose.x, _x.pose.y, _x.pose.theta))
      length = len(self.support_points)
      buff.write(_struct_I.pack(length))
      for val1 in self.support_points:
        _x = val1
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
      _x = self
      buff.write(_struct_fI.pack(_x.scale, _x.scale_level))
      length = len(self.descriptor.hist)
      buff.write(_struct_I.pack(length))
      for val1 in self.descriptor.hist:
        length = len(val1.vec)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *val1.vec))
      length = len(self.descriptor.variance)
      buff.write(_struct_I.pack(length))
      for val1 in self.descriptor.variance:
        length = len(val1.vec)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *val1.vec))
      length = len(self.descriptor.hit)
      buff.write(_struct_I.pack(length))
      for val1 in self.descriptor.hit:
        length = len(val1.vec)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *val1.vec))
      length = len(self.descriptor.miss)
      buff.write(_struct_I.pack(length))
      for val1 in self.descriptor.miss:
        length = len(val1.vec)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *val1.vec))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    @param str: byte array of serialized message
    @type  str: str
    """
    try:
      if self.pose is None:
        self.pose = geometry_msgs.msg.Pose2D()
      if self.descriptor is None:
        self.descriptor = flirtlib_ros.msg.DescriptorRos()
      end = 0
      _x = self
      start = end
      end += 24
      (_x.pose.x, _x.pose.y, _x.pose.theta,) = _struct_3d.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.support_points = []
      for i in range(0, length):
        val1 = geometry_msgs.msg.Point()
        _x = val1
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        self.support_points.append(val1)
      _x = self
      start = end
      end += 8
      (_x.scale, _x.scale_level,) = _struct_fI.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.descriptor.hist = []
      for i in range(0, length):
        val1 = flirtlib_ros.msg.Vector()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.vec = struct.unpack(pattern, str[start:end])
        self.descriptor.hist.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.descriptor.variance = []
      for i in range(0, length):
        val1 = flirtlib_ros.msg.Vector()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.vec = struct.unpack(pattern, str[start:end])
        self.descriptor.variance.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.descriptor.hit = []
      for i in range(0, length):
        val1 = flirtlib_ros.msg.Vector()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.vec = struct.unpack(pattern, str[start:end])
        self.descriptor.hit.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.descriptor.miss = []
      for i in range(0, length):
        val1 = flirtlib_ros.msg.Vector()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.vec = struct.unpack(pattern, str[start:end])
        self.descriptor.miss.append(val1)
      return self
    except struct.error as e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    @param buff: buffer
    @type  buff: StringIO
    @param numpy: numpy python module
    @type  numpy module
    """
    try:
      _x = self
      buff.write(_struct_3d.pack(_x.pose.x, _x.pose.y, _x.pose.theta))
      length = len(self.support_points)
      buff.write(_struct_I.pack(length))
      for val1 in self.support_points:
        _x = val1
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
      _x = self
      buff.write(_struct_fI.pack(_x.scale, _x.scale_level))
      length = len(self.descriptor.hist)
      buff.write(_struct_I.pack(length))
      for val1 in self.descriptor.hist:
        length = len(val1.vec)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(val1.vec.tostring())
      length = len(self.descriptor.variance)
      buff.write(_struct_I.pack(length))
      for val1 in self.descriptor.variance:
        length = len(val1.vec)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(val1.vec.tostring())
      length = len(self.descriptor.hit)
      buff.write(_struct_I.pack(length))
      for val1 in self.descriptor.hit:
        length = len(val1.vec)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(val1.vec.tostring())
      length = len(self.descriptor.miss)
      buff.write(_struct_I.pack(length))
      for val1 in self.descriptor.miss:
        length = len(val1.vec)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(val1.vec.tostring())
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    @param str: byte array of serialized message
    @type  str: str
    @param numpy: numpy python module
    @type  numpy: module
    """
    try:
      if self.pose is None:
        self.pose = geometry_msgs.msg.Pose2D()
      if self.descriptor is None:
        self.descriptor = flirtlib_ros.msg.DescriptorRos()
      end = 0
      _x = self
      start = end
      end += 24
      (_x.pose.x, _x.pose.y, _x.pose.theta,) = _struct_3d.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.support_points = []
      for i in range(0, length):
        val1 = geometry_msgs.msg.Point()
        _x = val1
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        self.support_points.append(val1)
      _x = self
      start = end
      end += 8
      (_x.scale, _x.scale_level,) = _struct_fI.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.descriptor.hist = []
      for i in range(0, length):
        val1 = flirtlib_ros.msg.Vector()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.vec = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        self.descriptor.hist.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.descriptor.variance = []
      for i in range(0, length):
        val1 = flirtlib_ros.msg.Vector()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.vec = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        self.descriptor.variance.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.descriptor.hit = []
      for i in range(0, length):
        val1 = flirtlib_ros.msg.Vector()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.vec = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        self.descriptor.hit.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.descriptor.miss = []
      for i in range(0, length):
        val1 = flirtlib_ros.msg.Vector()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        val1.vec = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        self.descriptor.miss.append(val1)
      return self
    except struct.error as e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

_struct_I = roslib.message.struct_I
_struct_fI = struct.Struct("<fI")
_struct_3d = struct.Struct("<3d")
