"""autogenerated by genmsg_py from RefScanRos.msg. Do not edit."""
import roslib.message
import struct

import geometry_msgs.msg
import flirtlib_ros.msg
import std_msgs.msg
import sensor_msgs.msg

class RefScanRos(roslib.message.Message):
  _md5sum = "11956f8796f4796e1612ff817c3f3dca"
  _type = "flirtlib_ros/RefScanRos"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """sensor_msgs/LaserScan scan
geometry_msgs/Pose pose
InterestPointRos[] pts
================================================================================
MSG: sensor_msgs/LaserScan
# Single scan from a planar laser range-finder
#
# If you have another ranging device with different behavior (e.g. a sonar
# array), please find or create a different message, since applications
# will make fairly laser-specific assumptions about this data

Header header            # timestamp in the header is the acquisition time of 
                         # the first ray in the scan.
                         #
                         # in frame frame_id, angles are measured around 
                         # the positive Z axis (counterclockwise, if Z is up)
                         # with zero angle being forward along the x axis
                         
float32 angle_min        # start angle of the scan [rad]
float32 angle_max        # end angle of the scan [rad]
float32 angle_increment  # angular distance between measurements [rad]

float32 time_increment   # time between measurements [seconds] - if your scanner
                         # is moving, this will be used in interpolating position
                         # of 3d points
float32 scan_time        # time between scans [seconds]

float32 range_min        # minimum range value [m]
float32 range_max        # maximum range value [m]

float32[] ranges         # range data [m] (Note: values < range_min or > range_max should be discarded)
float32[] intensities    # intensity data [device-specific units].  If your
                         # device does not provide intensities, please leave
                         # the array empty.

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: flirtlib_ros/InterestPointRos
# Corresponds to the InterestPoint type in flirtlib
# Includes both the point location and optionally a descriptor

geometry_msgs/Pose2D pose

geometry_msgs/Point[] support_points

float32 scale

uint32 scale_level

DescriptorRos descriptor


================================================================================
MSG: geometry_msgs/Pose2D
# This expresses a position and orientation on a 2D manifold.

float64 x
float64 y
float64 theta
================================================================================
MSG: flirtlib_ros/DescriptorRos
# Confirms to the Descriptor type in flirtlib
# For now, we only allow the beta grid descriptor

Vector[] hist
Vector[] variance
Vector[] hit
Vector[] miss

================================================================================
MSG: flirtlib_ros/Vector
# Vector message type used by a bunch of the flirtlib messages

float64[] vec
"""
  __slots__ = ['scan','pose','pts']
  _slot_types = ['sensor_msgs/LaserScan','geometry_msgs/Pose','flirtlib_ros/InterestPointRos[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.
    
    The available fields are:
       scan,pose,pts
    
    @param args: complete set of field values, in .msg order
    @param kwds: use keyword arguments corresponding to message field names
    to set specific fields. 
    """
    if args or kwds:
      super(RefScanRos, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.scan is None:
        self.scan = sensor_msgs.msg.LaserScan()
      if self.pose is None:
        self.pose = geometry_msgs.msg.Pose()
      if self.pts is None:
        self.pts = []
    else:
      self.scan = sensor_msgs.msg.LaserScan()
      self.pose = geometry_msgs.msg.Pose()
      self.pts = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    @param buff: buffer
    @type  buff: StringIO
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.scan.header.seq, _x.scan.header.stamp.secs, _x.scan.header.stamp.nsecs))
      _x = self.scan.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_7f.pack(_x.scan.angle_min, _x.scan.angle_max, _x.scan.angle_increment, _x.scan.time_increment, _x.scan.scan_time, _x.scan.range_min, _x.scan.range_max))
      length = len(self.scan.ranges)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(struct.pack(pattern, *self.scan.ranges))
      length = len(self.scan.intensities)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(struct.pack(pattern, *self.scan.intensities))
      _x = self
      buff.write(_struct_7d.pack(_x.pose.position.x, _x.pose.position.y, _x.pose.position.z, _x.pose.orientation.x, _x.pose.orientation.y, _x.pose.orientation.z, _x.pose.orientation.w))
      length = len(self.pts)
      buff.write(_struct_I.pack(length))
      for val1 in self.pts:
        _v1 = val1.pose
        _x = _v1
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.theta))
        length = len(val1.support_points)
        buff.write(_struct_I.pack(length))
        for val2 in val1.support_points:
          _x = val2
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _x = val1
        buff.write(_struct_fI.pack(_x.scale, _x.scale_level))
        _v2 = val1.descriptor
        length = len(_v2.hist)
        buff.write(_struct_I.pack(length))
        for val3 in _v2.hist:
          length = len(val3.vec)
          buff.write(_struct_I.pack(length))
          pattern = '<%sd'%length
          buff.write(struct.pack(pattern, *val3.vec))
        length = len(_v2.variance)
        buff.write(_struct_I.pack(length))
        for val3 in _v2.variance:
          length = len(val3.vec)
          buff.write(_struct_I.pack(length))
          pattern = '<%sd'%length
          buff.write(struct.pack(pattern, *val3.vec))
        length = len(_v2.hit)
        buff.write(_struct_I.pack(length))
        for val3 in _v2.hit:
          length = len(val3.vec)
          buff.write(_struct_I.pack(length))
          pattern = '<%sd'%length
          buff.write(struct.pack(pattern, *val3.vec))
        length = len(_v2.miss)
        buff.write(_struct_I.pack(length))
        for val3 in _v2.miss:
          length = len(val3.vec)
          buff.write(_struct_I.pack(length))
          pattern = '<%sd'%length
          buff.write(struct.pack(pattern, *val3.vec))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    @param str: byte array of serialized message
    @type  str: str
    """
    try:
      if self.scan is None:
        self.scan = sensor_msgs.msg.LaserScan()
      if self.pose is None:
        self.pose = geometry_msgs.msg.Pose()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.scan.header.seq, _x.scan.header.stamp.secs, _x.scan.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.scan.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 28
      (_x.scan.angle_min, _x.scan.angle_max, _x.scan.angle_increment, _x.scan.time_increment, _x.scan.scan_time, _x.scan.range_min, _x.scan.range_max,) = _struct_7f.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.scan.ranges = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.scan.intensities = struct.unpack(pattern, str[start:end])
      _x = self
      start = end
      end += 56
      (_x.pose.position.x, _x.pose.position.y, _x.pose.position.z, _x.pose.orientation.x, _x.pose.orientation.y, _x.pose.orientation.z, _x.pose.orientation.w,) = _struct_7d.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.pts = []
      for i in range(0, length):
        val1 = flirtlib_ros.msg.InterestPointRos()
        _v3 = val1.pose
        _x = _v3
        start = end
        end += 24
        (_x.x, _x.y, _x.theta,) = _struct_3d.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.support_points = []
        for i in range(0, length):
          val2 = geometry_msgs.msg.Point()
          _x = val2
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          val1.support_points.append(val2)
        _x = val1
        start = end
        end += 8
        (_x.scale, _x.scale_level,) = _struct_fI.unpack(str[start:end])
        _v4 = val1.descriptor
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v4.hist = []
        for i in range(0, length):
          val3 = flirtlib_ros.msg.Vector()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sd'%length
          start = end
          end += struct.calcsize(pattern)
          val3.vec = struct.unpack(pattern, str[start:end])
          _v4.hist.append(val3)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v4.variance = []
        for i in range(0, length):
          val3 = flirtlib_ros.msg.Vector()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sd'%length
          start = end
          end += struct.calcsize(pattern)
          val3.vec = struct.unpack(pattern, str[start:end])
          _v4.variance.append(val3)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v4.hit = []
        for i in range(0, length):
          val3 = flirtlib_ros.msg.Vector()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sd'%length
          start = end
          end += struct.calcsize(pattern)
          val3.vec = struct.unpack(pattern, str[start:end])
          _v4.hit.append(val3)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v4.miss = []
        for i in range(0, length):
          val3 = flirtlib_ros.msg.Vector()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sd'%length
          start = end
          end += struct.calcsize(pattern)
          val3.vec = struct.unpack(pattern, str[start:end])
          _v4.miss.append(val3)
        self.pts.append(val1)
      return self
    except struct.error as e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    @param buff: buffer
    @type  buff: StringIO
    @param numpy: numpy python module
    @type  numpy module
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.scan.header.seq, _x.scan.header.stamp.secs, _x.scan.header.stamp.nsecs))
      _x = self.scan.header.frame_id
      length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_7f.pack(_x.scan.angle_min, _x.scan.angle_max, _x.scan.angle_increment, _x.scan.time_increment, _x.scan.scan_time, _x.scan.range_min, _x.scan.range_max))
      length = len(self.scan.ranges)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(self.scan.ranges.tostring())
      length = len(self.scan.intensities)
      buff.write(_struct_I.pack(length))
      pattern = '<%sf'%length
      buff.write(self.scan.intensities.tostring())
      _x = self
      buff.write(_struct_7d.pack(_x.pose.position.x, _x.pose.position.y, _x.pose.position.z, _x.pose.orientation.x, _x.pose.orientation.y, _x.pose.orientation.z, _x.pose.orientation.w))
      length = len(self.pts)
      buff.write(_struct_I.pack(length))
      for val1 in self.pts:
        _v5 = val1.pose
        _x = _v5
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.theta))
        length = len(val1.support_points)
        buff.write(_struct_I.pack(length))
        for val2 in val1.support_points:
          _x = val2
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _x = val1
        buff.write(_struct_fI.pack(_x.scale, _x.scale_level))
        _v6 = val1.descriptor
        length = len(_v6.hist)
        buff.write(_struct_I.pack(length))
        for val3 in _v6.hist:
          length = len(val3.vec)
          buff.write(_struct_I.pack(length))
          pattern = '<%sd'%length
          buff.write(val3.vec.tostring())
        length = len(_v6.variance)
        buff.write(_struct_I.pack(length))
        for val3 in _v6.variance:
          length = len(val3.vec)
          buff.write(_struct_I.pack(length))
          pattern = '<%sd'%length
          buff.write(val3.vec.tostring())
        length = len(_v6.hit)
        buff.write(_struct_I.pack(length))
        for val3 in _v6.hit:
          length = len(val3.vec)
          buff.write(_struct_I.pack(length))
          pattern = '<%sd'%length
          buff.write(val3.vec.tostring())
        length = len(_v6.miss)
        buff.write(_struct_I.pack(length))
        for val3 in _v6.miss:
          length = len(val3.vec)
          buff.write(_struct_I.pack(length))
          pattern = '<%sd'%length
          buff.write(val3.vec.tostring())
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    @param str: byte array of serialized message
    @type  str: str
    @param numpy: numpy python module
    @type  numpy: module
    """
    try:
      if self.scan is None:
        self.scan = sensor_msgs.msg.LaserScan()
      if self.pose is None:
        self.pose = geometry_msgs.msg.Pose()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.scan.header.seq, _x.scan.header.stamp.secs, _x.scan.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      self.scan.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 28
      (_x.scan.angle_min, _x.scan.angle_max, _x.scan.angle_increment, _x.scan.time_increment, _x.scan.scan_time, _x.scan.range_min, _x.scan.range_max,) = _struct_7f.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.scan.ranges = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sf'%length
      start = end
      end += struct.calcsize(pattern)
      self.scan.intensities = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
      _x = self
      start = end
      end += 56
      (_x.pose.position.x, _x.pose.position.y, _x.pose.position.z, _x.pose.orientation.x, _x.pose.orientation.y, _x.pose.orientation.z, _x.pose.orientation.w,) = _struct_7d.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.pts = []
      for i in range(0, length):
        val1 = flirtlib_ros.msg.InterestPointRos()
        _v7 = val1.pose
        _x = _v7
        start = end
        end += 24
        (_x.x, _x.y, _x.theta,) = _struct_3d.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.support_points = []
        for i in range(0, length):
          val2 = geometry_msgs.msg.Point()
          _x = val2
          start = end
          end += 24
          (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
          val1.support_points.append(val2)
        _x = val1
        start = end
        end += 8
        (_x.scale, _x.scale_level,) = _struct_fI.unpack(str[start:end])
        _v8 = val1.descriptor
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v8.hist = []
        for i in range(0, length):
          val3 = flirtlib_ros.msg.Vector()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sd'%length
          start = end
          end += struct.calcsize(pattern)
          val3.vec = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
          _v8.hist.append(val3)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v8.variance = []
        for i in range(0, length):
          val3 = flirtlib_ros.msg.Vector()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sd'%length
          start = end
          end += struct.calcsize(pattern)
          val3.vec = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
          _v8.variance.append(val3)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v8.hit = []
        for i in range(0, length):
          val3 = flirtlib_ros.msg.Vector()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sd'%length
          start = end
          end += struct.calcsize(pattern)
          val3.vec = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
          _v8.hit.append(val3)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        _v8.miss = []
        for i in range(0, length):
          val3 = flirtlib_ros.msg.Vector()
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          pattern = '<%sd'%length
          start = end
          end += struct.calcsize(pattern)
          val3.vec = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
          _v8.miss.append(val3)
        self.pts.append(val1)
      return self
    except struct.error as e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

_struct_I = roslib.message.struct_I
_struct_7f = struct.Struct("<7f")
_struct_3I = struct.Struct("<3I")
_struct_7d = struct.Struct("<7d")
_struct_fI = struct.Struct("<fI")
_struct_3d = struct.Struct("<3d")
