"""autogenerated by genmsg_py from ScanMap.msg. Do not edit."""
import roslib.message
import struct

import flirtlib_ros.msg
import geometry_msgs.msg
import std_msgs.msg
import sensor_msgs.msg

class ScanMap(roslib.message.Message):
  _md5sum = "026e963f013904b1ec1b7676cf837306"
  _type = "flirtlib_ros/ScanMap"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """RefScanRos[] scans
================================================================================
MSG: flirtlib_ros/RefScanRos
sensor_msgs/LaserScan scan
geometry_msgs/Pose pose
InterestPointRos[] pts
================================================================================
MSG: sensor_msgs/LaserScan
# Single scan from a planar laser range-finder
#
# If you have another ranging device with different behavior (e.g. a sonar
# array), please find or create a different message, since applications
# will make fairly laser-specific assumptions about this data

Header header            # timestamp in the header is the acquisition time of 
                         # the first ray in the scan.
                         #
                         # in frame frame_id, angles are measured around 
                         # the positive Z axis (counterclockwise, if Z is up)
                         # with zero angle being forward along the x axis
                         
float32 angle_min        # start angle of the scan [rad]
float32 angle_max        # end angle of the scan [rad]
float32 angle_increment  # angular distance between measurements [rad]

float32 time_increment   # time between measurements [seconds] - if your scanner
                         # is moving, this will be used in interpolating position
                         # of 3d points
float32 scan_time        # time between scans [seconds]

float32 range_min        # minimum range value [m]
float32 range_max        # maximum range value [m]

float32[] ranges         # range data [m] (Note: values < range_min or > range_max should be discarded)
float32[] intensities    # intensity data [device-specific units].  If your
                         # device does not provide intensities, please leave
                         # the array empty.

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: flirtlib_ros/InterestPointRos
# Corresponds to the InterestPoint type in flirtlib
# Includes both the point location and optionally a descriptor

geometry_msgs/Pose2D pose

geometry_msgs/Point[] support_points

float32 scale

uint32 scale_level

DescriptorRos descriptor


================================================================================
MSG: geometry_msgs/Pose2D
# This expresses a position and orientation on a 2D manifold.

float64 x
float64 y
float64 theta
================================================================================
MSG: flirtlib_ros/DescriptorRos
# Confirms to the Descriptor type in flirtlib
# For now, we only allow the beta grid descriptor

Vector[] hist
Vector[] variance
Vector[] hit
Vector[] miss

================================================================================
MSG: flirtlib_ros/Vector
# Vector message type used by a bunch of the flirtlib messages

float64[] vec
"""
  __slots__ = ['scans']
  _slot_types = ['flirtlib_ros/RefScanRos[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.
    
    The available fields are:
       scans
    
    @param args: complete set of field values, in .msg order
    @param kwds: use keyword arguments corresponding to message field names
    to set specific fields. 
    """
    if args or kwds:
      super(ScanMap, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.scans is None:
        self.scans = []
    else:
      self.scans = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    @param buff: buffer
    @type  buff: StringIO
    """
    try:
      length = len(self.scans)
      buff.write(_struct_I.pack(length))
      for val1 in self.scans:
        _v1 = val1.scan
        _v2 = _v1.header
        buff.write(_struct_I.pack(_v2.seq))
        _v3 = _v2.stamp
        _x = _v3
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v2.frame_id
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = _v1
        buff.write(_struct_7f.pack(_x.angle_min, _x.angle_max, _x.angle_increment, _x.time_increment, _x.scan_time, _x.range_min, _x.range_max))
        length = len(_v1.ranges)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(struct.pack(pattern, *_v1.ranges))
        length = len(_v1.intensities)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(struct.pack(pattern, *_v1.intensities))
        _v4 = val1.pose
        _v5 = _v4.position
        _x = _v5
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v6 = _v4.orientation
        _x = _v6
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        length = len(val1.pts)
        buff.write(_struct_I.pack(length))
        for val2 in val1.pts:
          _v7 = val2.pose
          _x = _v7
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.theta))
          length = len(val2.support_points)
          buff.write(_struct_I.pack(length))
          for val3 in val2.support_points:
            _x = val3
            buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _x = val2
          buff.write(_struct_fI.pack(_x.scale, _x.scale_level))
          _v8 = val2.descriptor
          length = len(_v8.hist)
          buff.write(_struct_I.pack(length))
          for val4 in _v8.hist:
            length = len(val4.vec)
            buff.write(_struct_I.pack(length))
            pattern = '<%sd'%length
            buff.write(struct.pack(pattern, *val4.vec))
          length = len(_v8.variance)
          buff.write(_struct_I.pack(length))
          for val4 in _v8.variance:
            length = len(val4.vec)
            buff.write(_struct_I.pack(length))
            pattern = '<%sd'%length
            buff.write(struct.pack(pattern, *val4.vec))
          length = len(_v8.hit)
          buff.write(_struct_I.pack(length))
          for val4 in _v8.hit:
            length = len(val4.vec)
            buff.write(_struct_I.pack(length))
            pattern = '<%sd'%length
            buff.write(struct.pack(pattern, *val4.vec))
          length = len(_v8.miss)
          buff.write(_struct_I.pack(length))
          for val4 in _v8.miss:
            length = len(val4.vec)
            buff.write(_struct_I.pack(length))
            pattern = '<%sd'%length
            buff.write(struct.pack(pattern, *val4.vec))
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    @param str: byte array of serialized message
    @type  str: str
    """
    try:
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.scans = []
      for i in range(0, length):
        val1 = flirtlib_ros.msg.RefScanRos()
        _v9 = val1.scan
        _v10 = _v9.header
        start = end
        end += 4
        (_v10.seq,) = _struct_I.unpack(str[start:end])
        _v11 = _v10.stamp
        _x = _v11
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v10.frame_id = str[start:end]
        _x = _v9
        start = end
        end += 28
        (_x.angle_min, _x.angle_max, _x.angle_increment, _x.time_increment, _x.scan_time, _x.range_min, _x.range_max,) = _struct_7f.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        _v9.ranges = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        _v9.intensities = struct.unpack(pattern, str[start:end])
        _v12 = val1.pose
        _v13 = _v12.position
        _x = _v13
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v14 = _v12.orientation
        _x = _v14
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.pts = []
        for i in range(0, length):
          val2 = flirtlib_ros.msg.InterestPointRos()
          _v15 = val2.pose
          _x = _v15
          start = end
          end += 24
          (_x.x, _x.y, _x.theta,) = _struct_3d.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          val2.support_points = []
          for i in range(0, length):
            val3 = geometry_msgs.msg.Point()
            _x = val3
            start = end
            end += 24
            (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
            val2.support_points.append(val3)
          _x = val2
          start = end
          end += 8
          (_x.scale, _x.scale_level,) = _struct_fI.unpack(str[start:end])
          _v16 = val2.descriptor
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v16.hist = []
          for i in range(0, length):
            val4 = flirtlib_ros.msg.Vector()
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            pattern = '<%sd'%length
            start = end
            end += struct.calcsize(pattern)
            val4.vec = struct.unpack(pattern, str[start:end])
            _v16.hist.append(val4)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v16.variance = []
          for i in range(0, length):
            val4 = flirtlib_ros.msg.Vector()
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            pattern = '<%sd'%length
            start = end
            end += struct.calcsize(pattern)
            val4.vec = struct.unpack(pattern, str[start:end])
            _v16.variance.append(val4)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v16.hit = []
          for i in range(0, length):
            val4 = flirtlib_ros.msg.Vector()
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            pattern = '<%sd'%length
            start = end
            end += struct.calcsize(pattern)
            val4.vec = struct.unpack(pattern, str[start:end])
            _v16.hit.append(val4)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v16.miss = []
          for i in range(0, length):
            val4 = flirtlib_ros.msg.Vector()
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            pattern = '<%sd'%length
            start = end
            end += struct.calcsize(pattern)
            val4.vec = struct.unpack(pattern, str[start:end])
            _v16.miss.append(val4)
          val1.pts.append(val2)
        self.scans.append(val1)
      return self
    except struct.error as e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    @param buff: buffer
    @type  buff: StringIO
    @param numpy: numpy python module
    @type  numpy module
    """
    try:
      length = len(self.scans)
      buff.write(_struct_I.pack(length))
      for val1 in self.scans:
        _v17 = val1.scan
        _v18 = _v17.header
        buff.write(_struct_I.pack(_v18.seq))
        _v19 = _v18.stamp
        _x = _v19
        buff.write(_struct_2I.pack(_x.secs, _x.nsecs))
        _x = _v18.frame_id
        length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = _v17
        buff.write(_struct_7f.pack(_x.angle_min, _x.angle_max, _x.angle_increment, _x.time_increment, _x.scan_time, _x.range_min, _x.range_max))
        length = len(_v17.ranges)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(_v17.ranges.tostring())
        length = len(_v17.intensities)
        buff.write(_struct_I.pack(length))
        pattern = '<%sf'%length
        buff.write(_v17.intensities.tostring())
        _v20 = val1.pose
        _v21 = _v20.position
        _x = _v21
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v22 = _v20.orientation
        _x = _v22
        buff.write(_struct_4d.pack(_x.x, _x.y, _x.z, _x.w))
        length = len(val1.pts)
        buff.write(_struct_I.pack(length))
        for val2 in val1.pts:
          _v23 = val2.pose
          _x = _v23
          buff.write(_struct_3d.pack(_x.x, _x.y, _x.theta))
          length = len(val2.support_points)
          buff.write(_struct_I.pack(length))
          for val3 in val2.support_points:
            _x = val3
            buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
          _x = val2
          buff.write(_struct_fI.pack(_x.scale, _x.scale_level))
          _v24 = val2.descriptor
          length = len(_v24.hist)
          buff.write(_struct_I.pack(length))
          for val4 in _v24.hist:
            length = len(val4.vec)
            buff.write(_struct_I.pack(length))
            pattern = '<%sd'%length
            buff.write(val4.vec.tostring())
          length = len(_v24.variance)
          buff.write(_struct_I.pack(length))
          for val4 in _v24.variance:
            length = len(val4.vec)
            buff.write(_struct_I.pack(length))
            pattern = '<%sd'%length
            buff.write(val4.vec.tostring())
          length = len(_v24.hit)
          buff.write(_struct_I.pack(length))
          for val4 in _v24.hit:
            length = len(val4.vec)
            buff.write(_struct_I.pack(length))
            pattern = '<%sd'%length
            buff.write(val4.vec.tostring())
          length = len(_v24.miss)
          buff.write(_struct_I.pack(length))
          for val4 in _v24.miss:
            length = len(val4.vec)
            buff.write(_struct_I.pack(length))
            pattern = '<%sd'%length
            buff.write(val4.vec.tostring())
    except struct.error as se: self._check_types(se)
    except TypeError as te: self._check_types(te)

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    @param str: byte array of serialized message
    @type  str: str
    @param numpy: numpy python module
    @type  numpy: module
    """
    try:
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.scans = []
      for i in range(0, length):
        val1 = flirtlib_ros.msg.RefScanRos()
        _v25 = val1.scan
        _v26 = _v25.header
        start = end
        end += 4
        (_v26.seq,) = _struct_I.unpack(str[start:end])
        _v27 = _v26.stamp
        _x = _v27
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _struct_2I.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        _v26.frame_id = str[start:end]
        _x = _v25
        start = end
        end += 28
        (_x.angle_min, _x.angle_max, _x.angle_increment, _x.time_increment, _x.scan_time, _x.range_min, _x.range_max,) = _struct_7f.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        _v25.ranges = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sf'%length
        start = end
        end += struct.calcsize(pattern)
        _v25.intensities = numpy.frombuffer(str[start:end], dtype=numpy.float32, count=length)
        _v28 = val1.pose
        _v29 = _v28.position
        _x = _v29
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v30 = _v28.orientation
        _x = _v30
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _struct_4d.unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.pts = []
        for i in range(0, length):
          val2 = flirtlib_ros.msg.InterestPointRos()
          _v31 = val2.pose
          _x = _v31
          start = end
          end += 24
          (_x.x, _x.y, _x.theta,) = _struct_3d.unpack(str[start:end])
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          val2.support_points = []
          for i in range(0, length):
            val3 = geometry_msgs.msg.Point()
            _x = val3
            start = end
            end += 24
            (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
            val2.support_points.append(val3)
          _x = val2
          start = end
          end += 8
          (_x.scale, _x.scale_level,) = _struct_fI.unpack(str[start:end])
          _v32 = val2.descriptor
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v32.hist = []
          for i in range(0, length):
            val4 = flirtlib_ros.msg.Vector()
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            pattern = '<%sd'%length
            start = end
            end += struct.calcsize(pattern)
            val4.vec = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
            _v32.hist.append(val4)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v32.variance = []
          for i in range(0, length):
            val4 = flirtlib_ros.msg.Vector()
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            pattern = '<%sd'%length
            start = end
            end += struct.calcsize(pattern)
            val4.vec = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
            _v32.variance.append(val4)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v32.hit = []
          for i in range(0, length):
            val4 = flirtlib_ros.msg.Vector()
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            pattern = '<%sd'%length
            start = end
            end += struct.calcsize(pattern)
            val4.vec = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
            _v32.hit.append(val4)
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          _v32.miss = []
          for i in range(0, length):
            val4 = flirtlib_ros.msg.Vector()
            start = end
            end += 4
            (length,) = _struct_I.unpack(str[start:end])
            pattern = '<%sd'%length
            start = end
            end += struct.calcsize(pattern)
            val4.vec = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
            _v32.miss.append(val4)
          val1.pts.append(val2)
        self.scans.append(val1)
      return self
    except struct.error as e:
      raise roslib.message.DeserializationError(e) #most likely buffer underfill

_struct_I = roslib.message.struct_I
_struct_7f = struct.Struct("<7f")
_struct_fI = struct.Struct("<fI")
_struct_4d = struct.Struct("<4d")
_struct_2I = struct.Struct("<2I")
_struct_3d = struct.Struct("<3d")
